unit untPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  //Criamos um tipo complexo para que seja retornado um array na funo split
  arrRetorno = array of string;
  TfrmPrincipal = class(TForm)
    lbl1: TLabel;
    lbl2: TLabel;
    edtString: TEdit;
    edtSeparador: TEdit;
    btnProcessar: TButton;
    lbl3: TLabel;
    memRetorno: TMemo;
    procedure btnProcessarClick(Sender: TObject);
  private
    { Private declarations }
    function split(input, splitChar: string): arrRetorno;
  public
    { Public declarations }
  end;

var
  frmPrincipal: TfrmPrincipal;

implementation

{$R *.dfm}

{ TfrmPrincipal }

function TfrmPrincipal.split(input, splitChar: string): arrRetorno;
var
  inputLength, i, arrayDims: integer;
  inputAux : string;
begin
  inputLength := Length(input);
  inputAux := '';
  arrayDims:= 0;

  for i := 1 to inputLength do
  begin
    if input[i] = splitChar then
      arrayDims := arrayDims + 1;
  end;

  setLength(result, arrayDims+1);
  arrayDims:= 0;
 
  for i := 1 to inputLength do
  begin
    if input[i] <> splitChar then
      inputAux := inputAux + input[i]
    else
    begin
      result[arrayDims] := inputAux;
      arrayDims := arrayDims + 1;
      inputAux := '';
    end;

    if i >= inputLength then
    begin
      result[arrayDims] := inputAux;
      arrayDims := arrayDims + 1;
      inputAux := '';
    end;
  end;
end;

procedure TfrmPrincipal.btnProcessarClick(Sender: TObject);
var
  arrayRetorno: arrRetorno;
  i : integer;
begin
  memRetorno.Lines.Clear;
  arrayRetorno := split(edtString.Text, edtSeparador.Text);
  for i := 0 to High(arrayRetorno) do
  begin
    memRetorno.Lines.Add(arrayRetorno[i]);
  end;
end;

end.
